#Compiler PBCC 6, PBWin 10
#Compile Exe
#Dim All
#If %Def( %PB_CC32 )
#Console Off
#EndIf

#Include "..\bag.inc"
#Include "..\console.inc"

Global values() As String
Global bag As tBag

Function PBMain () As Long
	Local value As String
	ConInit
	ConCls 15, 0

	Bag_Init bag, %tBagTypes.eString, CodePtr( caseInsensitiveAscii )     ' Initialize the bag as case insensitive strings
	Map_Add "Smith", "A gunslinger in the old west."                      ' Add an item
	Map_Add "Jones", "The partner of Smith."                              ' Add an item
	Map_Add "Einstien", "A physicist of some reknown."                    ' Add an item
	value = "jONES"
	ConWriteln value + " is " + Map_Item( value )                         ' find an item
	ConClose -1
End Function

Sub Map_Add( pKey As String, value As String )
	Local index As Long
	index = Bag_Add( bag, ByRef pKey )                                    ' Get the index of the added pKey
	If bag.maxEntries_ > UBound(values())+1 Then                          ' If the bag holds more than our array
		ReDim Preserve values( bag.maxEntries_-1 )                          ' Resize our array to match
	End If
	values( index ) = value                                               ' Put the value at the same index as the pKey
End Sub

Function Map_Item( pKey As String ) As String
	Local index As Long
	index = Bag_IndexOf( bag, ByRef pKey )                                ' Find the pKey
	If index>-1 Then Function = values(index)                             ' Return the value
End Function
