#Include This Once

Sub TestInteger()
	Local bag As tBag
	Local a As Integer
	Local sp As Integer Ptr
	Local d As Integer
	Local i, j, ec As Long
	Local v(), u As Integer
	ReDim v(9)

	Array Assign v() = 1%, 2%, 3%, 4%, 5%, 6%, 7%, 8%, 9%, 10%


	Bag_Init bag, %tBagTypes.eInteger

	For i=0 To 9
		Bag_Add bag, ByRef v(i)
	Next

	For i=0 To bag.entryCount_-1
		Bag_Item bag, i, sp
		If @sp <> v(i) Then
			ConWriteln "Item got '" + Format$( @sp ) + "' not '" + Format$( v(i) ) + "'"
				Incr ec
		End If
	Next

	For i=0 To 9
		a = v(i)
		j = Bag_IndexOf( bag, ByRef a )
		If j<>i Then
			ConWriteln "IndexOf " + Format$( a ) + " returned "+Str$(j) + " not " + Str$(i)
				Incr ec
		End If
	Next

	For i=1 To 10
		Bag_RemoveAt bag, i-1
		If Bag_Count( bag )<> 10-i Then
			ConWriteln "i=" + Format$(i) + " has count of " + Format$( Bag_Count( bag ) )
				Incr ec
		End If
	Next

	For i=0 To 9
		Bag_Add bag, ByRef v(i)
	Next

	If Bag_Count( bag )<>10 Then
		ConWriteln "Bag_Count = " + Format$( Bag_Count( bag ) ) + " not 10"
			Incr ec
		End If

	For i=0 To 9
		Bag_Remove bag, ByRef v(i)
		If Bag_Count( bag )<> 9-i Then
			ConWriteln "i=" + Format$(i) + " has count of " + Format$( Bag_Count( bag ) )
				Incr ec
		End If
	Next

	If Bag_Count( bag )<>0 Then
		ConWriteln "Bag_Count = " + Format$( Bag_Count( bag ) ) + " not 0"
			Incr ec
		End If

	For i=0 To 9
		Bag_Add bag, ByRef v(i)
	Next


	For i = 0 To 9
		u = v(i)
		j = Bag_IndexOf( bag, ByRef u )
		If j<>i Then
			ConWriteln "IndexOf '" + Format$( u ) + "' got " + Format$(j) + " not " + Format$(i)
				Incr ec
		End If
	Next

	Bag_Release bag
	If ec=0 Then
		ConWriteln "Integer passed"
	Else
		ConWriteln "Integer had "+Format$(ec,"#,##0")+" errors"
	End If
End Sub
