#Include This Once

Type MyType
	value As StringZ * 10
	index As Long
End Type

Sub TestType()
	Local bag As tBag
	Local a As MyType
	Local sp As MyType Ptr
	Local d As Dword
	Local i, j, ec As Long
	Local v(), u As MyType
	ReDim v(9)

	Array Assign v() = "One","Two","Three","Four","Five","Six","Seven","Eight","Nine","Ten"


	Bag_Init bag, %tBagTypes.eType, 0, SizeOf( MyType )

	For i=0 To 9
		a.value = v(i)
		a.index = i+1
		Bag_Add bag, ByRef a
	Next

	For i=0 To bag.entryCount_-1
		a.value = v(i)
		a.index = i+1
		Bag_Item bag, i, sp
		If @sp <> a Then
			ConWriteln "Item got '" + @sp.value + "("+Format$(@sp.index)+")' not '" + a.value + "("+Format$(a.index)+")'"
					Incr ec
			End If
	Next

	For i=0 To 9
		a.value = v(i)
		a.index = i+1
		j = Bag_IndexOf( bag, ByRef a )
		If j<>i Then
			ConWriteln "IndexOf " + a + " returned "+Str$(j) + " not " + Str$(i)
					Incr ec
			End If
	Next

	For i=1 To 10
		Bag_RemoveAt bag, i-1
		If Bag_Count( bag )<> 10-i Then
			ConWriteln "i=" + Format$(i) + " has count of " + Format$( Bag_Count( bag ) )
					Incr ec
			End If
	Next

	For i=0 To 9
		a.value = v(i)
		a.index = i+1
		Bag_Add bag, ByRef a
	Next

	If Bag_Count( bag )<>10 Then
		ConWriteln "Bag_Count = " + Format$( Bag_Count( bag ) ) + " not 10"
				Incr ec
			End If

	For i=0 To 9
		a.value = v(i)
		a.index = i+1
		Bag_Remove bag, ByRef a
		If Bag_Count( bag )<> 9-i Then
			ConWriteln "i=" + Format$(i) + " has count of " + Format$( Bag_Count( bag ) )
					Incr ec
			End If
	Next

	If Bag_Count( bag )<>0 Then
		ConWriteln "Bag_Count = " + Format$( Bag_Count( bag ) ) + " not 0"
				Incr ec
			End If

	For i=0 To 9
		a.value = v(i)
		a.index = i+1
		Bag_Add bag, ByRef a
	Next


	For i = 0 To 9
		a.value = v(i)
		a.index = i+1
		j = Bag_IndexOf( bag, ByRef a )
		If j<>i Then
			ConWriteln "IndexOf '" + u + "' got " + Format$(j) + " not " + Format$(i)
					Incr ec
			End If
	Next

	Bag_Release bag
	If ec=0 Then
		ConWriteln "Type passed"
	Else
		ConWriteln "Type had "+Format$(ec,"#,##0")+" errors"
	End If
End Sub
