#Include This Once

Sub TestWStringI()
	Local bag As tBag
	Local a As WString
	Local sp As WString Ptr
	Local d As Dword
	Local i, j, ec As Long
	Local v(), u As WString
	ReDim v(9)

	Array Assign v() = "One","Two","Three","Four","Five","Six","Seven","Eight","Nine","Ten"


	Bag_Init bag, %tBagTypes.eWString, CodePtr( caseInsensitiveAscii )

	For i=0 To 9
		Bag_Add bag, ByRef v(i)
	Next

	For i=0 To bag.entryCount_-1
		Bag_Item bag, i, sp
		If @sp <> v(i) Then
			ConWriteln "Item got '" + @sp + "' not '" + v(i) + "'"
				Incr ec
		End If
	Next

	For i=0 To 9
		a = v(i)
		j = Bag_IndexOf( bag, ByRef a )
		If j<>i Then
			ConWriteln "IndexOf " + a + " returned "+Str$(j) + " not " + Str$(i)
				Incr ec
		End If
	Next

	For i=1 To 10
		Bag_RemoveAt bag, i-1
		If Bag_Count( bag )<> 10-i Then
			ConWriteln "i=" + Format$(i) + " has count of " + Format$( Bag_Count( bag ) )
				Incr ec
		End If
	Next

	For i=0 To 9
		Bag_Add bag, ByRef v(i)
	Next

	If Bag_Count( bag )<>10 Then
		ConWriteln "Bag_Count = " + Format$( Bag_Count( bag ) ) + " not 10"
			Incr ec
		End If

	For i=0 To 9
		Bag_Remove bag, ByRef v(i)
		If Bag_Count( bag )<> 9-i Then
			ConWriteln "i=" + Format$(i) + " has count of " + Format$( Bag_Count( bag ) )
				Incr ec
		End If
	Next

	If Bag_Count( bag )<>0 Then
		ConWriteln "Bag_Count = " + Format$( Bag_Count( bag ) ) + " not 0"
			Incr ec
		End If

	For i=0 To 9
		Bag_Add bag, ByRef v(i)
	Next


	For i = 0 To 9
		u = v(i)
		j = Bag_IndexOf( bag, ByRef u )
		If j<>i Then ConWriteln "IndexOf '" + u + "' got " + Format$(j) + " not " + Format$(i)
		u = UCase$( v(i) )
		j = Bag_IndexOf( bag, ByRef u )
		If j<>i Then ConWriteln "IndexOf '" + u + "' got " + Format$(j) + " not " + Format$(i)
		u = LCase$( v(i) )
		j = Bag_IndexOf( bag, ByRef u )
		If j<>i Then ConWriteln "IndexOf '" + u + "' got " + Format$(j) + " not " + Format$(i)
	Next

	Bag_Clear bag

	' Test insensitive versions of same string
	Local w() As String
	ReDim w(2)
	Array Assign w() = "One", "ONE", "one"
	For i=0 To 2
		a = w(i)
		Bag_Add bag, ByRef a
		j = Bag_Count( bag )
		If j<> 1 Then ConWriteln "Got count " + Format$(j) + " instead of 1"
	Next

	For i=0 To 2
		a = w(i)
		j = Bag_IndexOf( bag, ByRef a )
		If j<> 0 Then
			ConWriteln "Got index " + Format$(j) + " instead of 0"
				Incr ec
		End If
	Next

	Bag_Release bag

	If ec=0 Then
		ConWriteln "WStringI passed"
	Else
		ConWriteln "WStringI had "+Format$(ec,"#,##0")+" errors"
	End If
End Sub
