#Include This Once

Type tBagEach
	obj_ As tBag Ptr
	index_ As Long
End Type

Sub BagEach_Reset( iterator As tBagEach, obj As tBag )
	iterator.obj_ = VarPtr( obj )
	iterator.index_ = -1
End Sub

Function BagEach_Next( iterator As tBagEach ) As Long
	Local e As tBagEntry Ptr
	If IsFalse( iterator.obj_ ) Then Exit Function
	If iterator.index_ < iterator.@obj_.entryCount_ Then
		Incr iterator.index_
		e = iterator.@obj_.entries_ + (iterator.index_ * iterator.@obj_.eSize_)
		While iterator.index_ < iterator.@obj_.entryCount_ And @e.hashCode_=0
			Incr iterator.index_
			e += iterator.@obj_.eSize_
		Wend
		If iterator.index_ < iterator.@obj_.entryCount_ Then
			Function = -1
		End If
	End If
End Function

Function BagEach_Index( iterator As tBagEach ) As Long
	Local obj As tBag Ptr
	If IsFalse( iterator.obj_ ) Then Function=-1: Exit Function
	If iterator.index_ >= 0 And iterator.index_ < iterator.@obj_.entryCount_ Then
		Function = iterator.index_
	Else
		Function = -1
	End If
End Function

Sub BagEach_Item( iterator As tBagEach, valueRef As Dword )
	Local sp As String Ptr
	Local e As tBagEntry Ptr
	If IsFalse( iterator.obj_ ) Then
		valueRef = 0
		Exit Sub
	End If
	If iterator.index_ >= 0 And iterator.index_ < iterator.@obj_.entryCount_ Then
		e = iterator.@obj_.entries_ + ( iterator.index_ * iterator.@obj_.eSize_ )
		If @e.hashCode_ Then valueRef = VarPtr( @e.key_ ) Else valueRef = 0
	Else
		valueRef = 0
	End If
End Sub
