#Compiler PBWin 10, PBCC 6
#Compile Exe
#Dim All
#If %Def( %PB_CC32 )
#Console Off
#EndIf

#Include Once "..\bag.inc"
#Include Once "..\bagEach.inc"
#Include Once "..\console.inc"

Type Customers
	Code As StringZ*6                               ' Key to access the customer
	Name As StringZ*40                              ' Customers name
End Type

Function PBMain () As Long
	Local bag As tBag                               ' The bag we'll be filling
	Local it As tBagEach                            ' The bag iterator
	Local rec As Customers                          ' A customer record
	Local i, hCust As Long
	Local sp As StringZ Ptr
	Local value As String

	ConInit
	ConCls 13, 0

	Bag_Init bag, %tBagTypes.eStringZ, _            ' Initialize the bag
						CodePtr( caseInsensitiveAscii ), 6

	hCust = FreeFile                                ' Get a file handle
	Open "recs.dat" _                               ' Open the file
		For Random    _
		As #hCust     _
		Len = SizeOf( Customers )

	For i=1 To Lof(#hCust)\SizeOf(Customers)        ' Loop through all records
		Get #hCust, i, rec                            ' Get a record
		Bag_Add bag, ByRef rec.Code                   ' Add the code to the bag
	Next


	For i=0 To bag.entryCount_-1 Step 2             ' Every even item
		Bag_RemoveAt bag, i                           ' Remove from the bag
	Next

	BagEach_Reset it, bag                           ' Reset the iterator

	While BagEach_Next( it )                        ' Iterate over each item that's left
		BagEach_Item it, sp                           ' Get an item
		value = @sp                                   ' Convert to PB string for Con routine
		ConWrite value                                ' Write key
		ConWrite " : "                                ' Write separator
		i = BagEach_Index( it ) + 1                   ' Bag index (0 to n-1), Record # (1 to n)
		Get #hCust, i, rec                            ' Get a record
		value = rec.Name                              ' Convert to PB String for Con routine
		ConWriteln value                              ' Display name
	Wend
	Close #hCust                                    ' Close the file

	ConClose -1
End Function
