#Include This Once

Sub TestDWord()
	Local bag As tBag
	Local a As Dword
	Local sp As Dword Ptr
	Local d As Dword
	Local i, j, ec As Long
	Local v(), u As Dword
	ReDim v(9)

	Array Assign v() = 1???, 2???, 3???, 4???, 5???, 6???, _
										 7???, 8???, 9???, 10???


	Bag_Init bag, %tBagTypes.eDWord

	For i=0 To 9
		Bag_Add bag, ByRef v(i)
	Next

	For i=0 To bag.entryCount_-1
		Bag_Item bag, i, sp
		If @sp <> v(i) Then
			ConWriteln "Item got '" + Format$( @sp ) + "' not '" + Format$( v(i) ) + "'"
			Incr ec
		End If
	Next

	For i=0 To 9
		a = v(i)
		j = Bag_IndexOf( bag, ByRef a )
		If j<>i Then
			ConWriteln "IndexOf " + Format$( a ) + " returned "+Str$(j) + " not " + Str$(i)
			Incr ec
		End If
	Next

	For i=1 To 10
		Bag_RemoveAt bag, i-1
		If Bag_Count( bag )<> 10-i Then
			ConWriteln "i=" + Format$(i) + " has count of " + Format$( Bag_Count( bag ) )
			Incr ec
		End If
	Next

	For i=0 To 9
		Bag_Add bag, ByRef v(i)
	Next

	If Bag_Count( bag )<>10 Then
		ConWriteln "Bag_Count = " + Format$( Bag_Count( bag ) ) + " not 10"
			Incr ec
	End If

	For i=0 To 9
		Bag_Remove bag, ByRef v(i)
		If Bag_Count( bag )<> 9-i Then
			ConWriteln "i=" + Format$(i) + " has count of " + Format$( Bag_Count( bag ) )
			Incr ec
		End If
	Next

	If Bag_Count( bag )<>0 Then
		ConWriteln "Bag_Count = " + Format$( Bag_Count( bag ) ) + " not 0"
			Incr ec
	End If

	For i=0 To 9
		Bag_Add bag, ByRef v(i)
	Next


	For i = 0 To 9
		u = v(i)
		j = Bag_IndexOf( bag, ByRef u )
		If j<>i Then
			ConWriteln "IndexOf '" + Format$( u ) + "' got " + Format$(j) + " not " + Format$(i)
			Incr ec
		End If
	Next

	Bag_Release bag
	If ec=0 Then
		ConWriteln "DWord passed"
	Else
		ConWriteln "DWord had "+Format$(ec,"#,##0")+" errors"
	End If
End Sub
